/* Tecnisa - Tecnologia em Informtica

Nome: 0099_GERSTP_ULTIMO_DIA_MES.SQL

Descrio:
 Procedimento para encontrar o ltimo dia do ms de uma determinada data

Criao:  Robert Pereira Pinto

Manutenes:
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE 
	        O.NAME = 'ULTIMO_DIA_MES'  AND 
	        TYPE = 'P' 			        AND
	        U.UID = O.UID             		        AND 
	        U.NAME = USER)

  DROP PROCEDURE ULTIMO_DIA_MES
  GO

CREATE PROCEDURE ULTIMO_DIA_MES @P_DTDATA DATETIME OUTPUT

AS

DECLARE @V_CONVERTE_DATA VARCHAR(10);

BEGIN
   SET @V_CONVERTE_DATA = CONVERT(VARCHAR, @P_DTDATA, 103);
   IF  SUBSTRING(@V_CONVERTE_DATA,4,2) IN ('01','03','05','07','08','10','12')
   BEGIN
      SET @V_CONVERTE_DATA = '31' + SUBSTRING(@V_CONVERTE_DATA,3,8);
   END
   ELSE
   IF SUBSTRING(@V_CONVERTE_DATA,4,2) IN ('04','06','09','11')
   BEGIN
      SET @V_CONVERTE_DATA = '30' + SUBSTRING(@V_CONVERTE_DATA,3,8);
   END
   ELSE
   IF SUBSTRING(@V_CONVERTE_DATA,4,2) = '02'
   BEGIN
   	IF ISDATE('29' + SUBSTRING(@V_CONVERTE_DATA,3,8)) = 1
      BEGIN
         SET @V_CONVERTE_DATA = '29' + SUBSTRING(@V_CONVERTE_DATA,3,8);
      END
      ELSE
      BEGIN
      	SET @V_CONVERTE_DATA = '28' + SUBSTRING(@V_CONVERTE_DATA,3,8);
      END;
   END;

   SET @P_DTDATA = CONVERT(DATETIME, @V_CONVERTE_DATA);
END;
GO