<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaEventoctbl extends \Doctrine\ORM\EntityRepository {
    
    
    public function retornaContasContabeis($nrorg, $nrevento, $nrestrutura, $dtcompetencia, $idVinculoAtivo, $nrTpEventoctbl = null, $nrTipoMovimento = null) {
        
        $fpaEventoctbl =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventoctbl';
        
        $params = array('nrorg' => $nrorg, 'nreventom' => $nrevento, 'nrestruturam' => $nrestrutura, 'idvincativo' => $idVinculoAtivo,
        'dtinivigencia' => $dtcompetencia, 'nrtpeventoctbl' => $nrTpEventoctbl, 'nrtipomoviment' => $nrTipoMovimento);
        
        if (is_null($nrTpEventoctbl)) {
            $cond_Tpeventoctbl = ' AND e.nrtpeventoctbl IS NULL';
            unset($params['nrtpeventoctbl']);
        } else {
            $cond_Tpeventoctbl = ' AND e.nrtpeventoctbl = :nrtpeventoctbl';
        }
        
        if (is_null($nrTipoMovimento)) {
            $cond_Tpmoviment = ' AND e.nrtipomoviment IS NULL';
            unset($params['nrtipomoviment']);
        } else {
            $cond_Tpmoviment = ' AND e.nrtipomoviment = :nrtipomoviment';
        }
        
        /* Busca uma associação para a estrutura e tipo informados */
$sql = <<<SQL
SELECT e FROM $fpaEventoctbl e
WHERE e.nrorg = :nrorg 
    AND e.nreventom = :nreventom
    AND e.nrestruturam = :nrestruturam
    AND e.idvincativo = :idvincativo
    AND e.dtinivigencia <= :dtinivigencia
    $cond_Tpeventoctbl
    $cond_Tpmoviment
ORDER BY e.dtinivigencia DESC 
    
SQL;
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
         
        /* Caso não encontre associação para a estrutura e tipo informados, busca uma associação para a estrutura e sem tipo moviment*/
        if (empty($resultado)) {
       
            $sql = <<<SQL
SELECT e FROM $fpaEventoctbl e
WHERE e.nrorg = :nrorg 
    AND e.nreventom = :nreventom
    AND e.nrestruturam = :nrestruturam
    AND e.idvincativo = :idvincativo
    AND e.dtinivigencia <= :dtinivigencia
    AND e.nrtipomoviment IS NULL
    $cond_Tpeventoctbl
ORDER BY e.dtinivigencia DESC 
    
SQL;
            if(isset($params['nrtipomoviment'])) unset($params['nrtipomoviment']);
            $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
        }
        
        /* Caso não encontre associação para a estrutura e tipo informados, busca uma associação para a estrutura e sem tipo ctbl */
        if (empty($resultado)) {
       
            $sql = <<<SQL
SELECT e FROM $fpaEventoctbl e
WHERE e.nrorg = :nrorg 
    AND e.nreventom = :nreventom
    AND e.nrestruturam = :nrestruturam
    AND e.idvincativo = :idvincativo
    AND e.dtinivigencia <= :dtinivigencia
    AND e.nrtpeventoctbl IS NULL
    $cond_Tpmoviment
ORDER BY e.dtinivigencia DESC 
    
SQL;

            if(isset($params['nrtpeventoctbl'])) unset($params['nrtpeventoctbl']);
            if ($nrTipoMovimento) $params['nrtipomoviment'] = $nrTipoMovimento;
            $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
        }
        
        /* Caso não encontre associação para a estrutura e tipo informados, busca uma associação para a estrutura e sem tipo */
        if (empty($resultado)) {
            
            $sql = <<<SQL
SELECT e FROM $fpaEventoctbl e
WHERE e.nrorg = :nrorg 
    AND e.nreventom = :nreventom
    AND e.nrestruturam = :nrestruturam
    AND e.idvincativo = :idvincativo
    AND e.dtinivigencia <= :dtinivigencia
    AND e.nrtpeventoctbl IS NULL
    AND e.nrtipomoviment IS NULL
ORDER BY e.dtinivigencia DESC
        
SQL;
            if(isset($params['nrtpeventoctbl'])) unset($params['nrtpeventoctbl']);
            if(isset($params['nrtipomoviment'])) unset($params['nrtipomoviment']);
            
            $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
        }
        
        /* Caso não encontre associação para a estrutura informada e sem tipo, busca uma associação sem estrutura para o tipo informado */
        if (empty($resultado)) {
         
            $sql = <<<SQL
SELECT e FROM $fpaEventoctbl e
WHERE e.nrorg = :nrorg 
    AND e.nreventom = :nreventom
    AND e.nrestruturam IS NULL
    AND e.idvincativo = :idvincativo
    AND e.dtinivigencia <= :dtinivigencia
    $cond_Tpeventoctbl
    $cond_Tpmoviment
ORDER BY e.dtinivigencia DESC
    
SQL;
            
            if ($nrTpEventoctbl) $params['nrtpeventoctbl'] = $nrTpEventoctbl;
            if ($nrTipoMovimento) $params['nrtipomoviment'] = $nrTipoMovimento;
            unset($params['nrestruturam']);
            $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
        }
        
        /* Caso não encontre associação para a estrutura informada e sem tipo, busca uma associação sem estrutura para o tipo informado */
        if (empty($resultado)) {
         
            $sql = <<<SQL
SELECT e FROM $fpaEventoctbl e
WHERE e.nrorg = :nrorg 
    AND e.nreventom = :nreventom
    AND e.nrestruturam IS NULL
    AND e.idvincativo = :idvincativo
    AND e.dtinivigencia <= :dtinivigencia
    AND e.nrtipomoviment IS NULL
    $cond_Tpeventoctbl
ORDER BY e.dtinivigencia DESC
    
SQL;
            if ($nrTpEventoctbl) $params['nrtpeventoctbl'] = $nrTpEventoctbl;
            if(isset($params['nrtipomoviment'])) unset($params['nrtipomoviment']);
            unset($params['nrestruturam']);
            $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
        }

/* Caso não encontre associação para a estrutura informada e sem tipo, busca uma associação sem estrutura para o tipo informado */
        if (empty($resultado)) {
         
            $sql = <<<SQL
SELECT e FROM $fpaEventoctbl e
WHERE e.nrorg = :nrorg 
    AND e.nreventom = :nreventom
    AND e.nrestruturam IS NULL
    AND e.idvincativo = :idvincativo
    AND e.dtinivigencia <= :dtinivigencia
    AND e.nrtpeventoctbl IS NULL
    $cond_Tpmoviment
ORDER BY e.dtinivigencia DESC
    
SQL;
            if ($nrTipoMovimento) $params['nrtipomoviment'] = $nrTipoMovimento;
            if(isset($params['nrtpeventoctbl'])) unset($params['nrtpeventoctbl']);
            unset($params['nrestruturam']);
            $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
        }
        
        /* Caso não encontre associação sem estrutura e para o tipo informado, busca uma associação sem estrutura e sem tipo */
        if (empty($resultado)) {
            
            $sql = <<<SQL
SELECT e FROM $fpaEventoctbl e
WHERE e.nrorg = :nrorg 
    AND e.nreventom = :nreventom
    AND e.nrestruturam IS NULL
    AND e.idvincativo = :idvincativo
    AND e.dtinivigencia <= :dtinivigencia
    AND e.nrtpeventoctbl IS NULL
    AND e.nrtipomoviment IS NULL
ORDER BY e.dtinivigencia DESC
        
SQL;
            if(isset($params['nrtipomoviment'])) unset($params['nrtipomoviment']);
            
            $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
        }
        
        return $resultado;
    }
    
    public function getFpaeventoctbl($nrorg, $nreventom, $nrtipomoviment, $nrtpeventoctbl, $nrestruturam, $nreventoctbl = null){
        $fpaEventoctbl =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventoctbl';
            
        $sql = <<<SQL
           SELECT
                ec      
            FROM
                $fpaEventoctbl ec
            WHERE
                ec.nrorg = :p_nrorg                           
                AND ec.nreventom = :p_nreventom                           
                AND (
                    ec.nreventoctbl <> :p_nreventoctbl      
                    OR :p_nreventoctbl IS NULL
                )
                AND  
                (
                    (
                        ec.nrtipomoviment = :p_nrtipomoviment                               
                        AND :p_nrtipomoviment IS NOT NULL                 
                    )                           
                    OR (
                        ec.nrtipomoviment IS NULL                               
                        AND :p_nrtipomoviment IS NULL                 
                    )
                )                 
                AND                  
                (
                    (
                        ec.nrtpeventoctbl = :p_nrtpeventoctbl                                   
                        AND :p_nrtpeventoctbl IS NOT NULL                     
                    )                               
                    OR (
                        ec.nrtpeventoctbl IS NULL                                   
                        AND :p_nrtpeventoctbl IS NULL                     
                    )                 
                )                           
                AND                  
                (
                    (
                        ec.nrestruturam = :p_nrestruturam                                   
                        AND :p_nrestruturam IS NOT NULL                     
                    )                               
                    OR (
                        ec.nrestruturam IS NULL                         
                        AND :p_nrestruturam IS NULL                     
                    )                 
                )
SQL;
    
        $params = array(
            'p_nrorg'          => $nrorg,
            'p_nreventom'      => $nreventom,
            'p_nrtipomoviment' => $nrtipomoviment,
            'p_nrtpeventoctbl' => $nrtpeventoctbl,
            'p_nrestruturam'   => $nrestruturam,
            'p_nreventoctbl'   => $nreventoctbl,
        );
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }    
    
} 