function Cmp03900_LancamentoAutorizacaoDeFornecimento_Service(restEngine){
    
    this.validacoesIniciais = function() {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validacoesIniciais', {
            "requestType": "Row",
            "row": {}
        });
    };
    
    this.retornaComprador = function() {
        return restEngine.post('cmp#/crud/comprador_operador', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDOPERADOR",  "value": getLocalVar('CDOPERADOR'),    "operator": "="},
                {"name": "NRORG",       "value": getLocalVar('NRORG'),         "operator": "="}
            ]
        });
    };
    
    this.infoAF = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/infoAF', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,    "operator": "="},
                {"name": "CDFILDEST",    "value": dados.CDFILDEST,    "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,   "operator": "="}
            ]
        });
    };
    
    this.parasupri = function() {
        return restEngine.post('cmp#/crud/parasupri', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILIAL",    "value": getLocalVar('CDFILCENTCMP'),    "operator": "="},
                {"name": "NRORG",       "value": getLocalVar('NRORG'),           "operator": "="}
            ]
        });
    };
    
    this.salvarProduto = function(produto, oldProduto, dadosAF) {
        oldProduto = oldProduto ? oldProduto : {};
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarProduto', {
            "requestType": "DataSet",
            "dataset": [produto, oldProduto, dadosAF]
        });
    };
    
    this.salvarImposto = function(impostos) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarImposto', {
            "requestType": "DataSet",
            "dataset": impostos
        });
    };
    
    this.itemautf = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/itemautf', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,    "operator": "="},
                {"name": "CDFILDEST",    "value": dados.CDFILDEST,    "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,   "operator": "="},
                {"name": "CDMARCA",      "value": dados.CDMARCA,      "operator": "="},
                {"name": "CDPRODUTO",    "value": dados.CDPRODUTO,    "operator": "="}
            ]
        });
    };
    
    this.itemautfSave = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/itemautf/save', {
            "requestType": "Row",
            "row": dados
        });
    };
    
    this.formaPagamento = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/af_formaPagamento', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,       "operator": "="},
                {"name": "CDFILIAL",     "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,      "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.salvarDadosAF = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarEdicaoAF', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.salvarFormaPagamento = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarFormaPagamento', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.salvarEncargo = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarEncargo', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.editarJustificativa = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/editarJustificativa', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.excluirProduto = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/excluirProduto', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.validaFornecedor = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaFornecedor', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.insereImpostos = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/insereImpostos', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.empresasPorUnidade = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/empresasPorUnidade', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILIAL",    "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRORG",       "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.empresaClientePrincipal = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/empresaClientePrincipal', {
            "requestType": "FilterData",
            "filter": [
                {"name": "IDCLIENPRIN",  "value": "S",                   "operator": "="},
                {"name": "CDFILIAL",     "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.parametrosCompras = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/parametrosCompras', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILIAL",    "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRORG",       "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.atualizarInconsistencias = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/atualizarInconsistencias', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.dadosFornecedor = function (dados) {
        return restEngine.post('cmp#/crud/fornecedor', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFORNECED",    "value": dados.CDFORNECED,      "operator": "="},
                {"name": "NRORG",         "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.excluirAF = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/excluirAF', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.consisteOrcamento = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/consisteOrcamento', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.consisteDsincons = function(row, produtos, dsinconsitaf) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/consisteDsincons', {
            "requestType": "DataSet",
            "dataset": [row, produtos, dsinconsitaf]
        });
    };
    
    this.atualizaProdutosTipoBaixa = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/atualizaProdutosTipoBaixa', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.atualizaItemBaixa = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/atualizaItemBaixa', {
            "requestType": "DataSet",
            "dataset": row
        });
    };
    
    this.salvarJustificativas = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarJustificativas', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.validaFilial = function(cdfilial) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaFilial', {
            "requestType": "Row",
            "row": {"CDFILIAL": cdfilial}
        });
    };
    
    this.validaComprador = function (comprador, operador) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaComprador', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDCOMPRADOR",   "value": comprador,             "operator": "="},
                {"name": "CDOPERADOR",    "value": operador,              "operator": "="},
                {"name": "NRORG",         "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.confirmaSenhaComprador = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/confirmaSenhaComprador', {
            "requestType": "Row",
            "row": dados
        });
    };
    
    this.retornaDadosFornecedor = function (dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/retornaDadosFornecedor', {
            "requestType": "Row",
            "row": dados
        });
    };
    
    this.validaDataLancamento = function (row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaDataLancamento', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.retornaFormpgto = function(cdformpgto) {
        return restEngine.post('cmp#/crud/formpgto', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFORMPGTO",    "value": cdformpgto,              "operator": "="},
                {"name": "NRORG",         "value": getLocalVar('NRORG'),    "operator": "="}
            ]
        });
    };
    
    this.salvarAdicaoAF = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarAdicaoAF', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.finalizaAdicaoAF = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/finalizaAdicaoAF', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.validaDataEntrega = function (row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaDataEntrega', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.validaProduto = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaProduto', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.validaProdMarca = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaProdMarca', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.salvarMensagem = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarMensagem', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.excluirMensagem = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/excluirMensagem', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.novoCodigoMensagem = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/novoCodigoMensagem', {
            "requestType": "Row",
            "row": row
        });
    };
    
    
    this.utilizaWorkflow = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', {
            "requestType": "Row",
            "row": row
        });
    };

    this.retornaParametroCotacao = function (centralCompras) {
        var route = 'cmp_fornecimento_autorizacaoFornecimento#/AF/retornaParametroCotacao';
        var payload = {
            "requestType": "Row",
            "row": { "CDFILCENTCMP": centralCompras }
        };
        return restEngine.post(route, payload);
    };
    
    this.retornaCotacaoProduto = function (row) {
        var route = 'cmp_fornecimento_autorizacaoFornecimento#/AF/retornaCotacaoProduto';
        var payload = {
            "requestType": "Row",
            "row": row
        };
        return restEngine.post(route, payload);
    };
    
    this.getFormPgtoFornecedor = function (row) {
        var route = 'cmp_fornecimento_autorizacaoFornecimento#/AF/getFormPgtoFornecedor';
        var payload = {
            "requestType": "Row",
            "row": row
        };
        return restEngine.post(route, payload);
    };
    
    this.salvaJustLancAf = function (cdfildest, cdfillanc, nrautoforn, dsmotvafalcada) {
        
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvaJustLancAf', {
            "requestType": "Row",
            "row": {
                "CDFILDEST": cdfildest,
                "CDFILLANC": cdfillanc,
                "NRAUTOFORN": nrautoforn,
                "DSMOTVAFALCADA": dsmotvafalcada
            }
        });
        
    };
    
    this.proceConsisteOrcamentoGopWorkflow = function (cdfildest, cdfillanc, nrautoforn) {
        
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/consisteOrcamentoGopWorkflow', {
            "requestType": "Row",
            "row": {
                "CDFILDEST": cdfildest,
                "CDFILLANC": cdfillanc,
                "NRAUTOFORN": nrautoforn
            }
        });
        
    };
    
    this.validateAllProducts = function(saveProducts) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validateAllProducts', {
            "requestType": "DataSet",
            "dataset": saveProducts
        });
    };
    
    this.saveAllProduct = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/saveAllProduct', {
            "requestType": "Row",
            "row": row
        });
    };

    this.retornaDataLancamento = function (codigoFilialDestino) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/retornaDataLancamento', {
            'requestType': 'Row',
            'row': {
                CDFILDEST: codigoFilialDestino
            }
        });
        
    };
    
    /**
     * [INÍCIO] ANEXO
     */
    
    /**
     * Adição de AF
     */
    
    this.saveAnexoLocal = function(currentRow){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvaAnexoLocalAF', {
          "requestType": "Row",
          "row": currentRow
      });
    };
    
    this.deleteAnexoLocal = function(dataSet){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/deletaAnexoLocalAF', {
          "requestType": "DataSet",
          "dataset": dataSet
      });
    };
    
    /**
     * Visualização da AF
     */
    
    this.salvaAnexoGrid = function(currentRow){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvaAnexoGridAF', {
          "requestType": "Row",
          "row": currentRow
      });
    };
    
    this.deleteAnexoGrid = function(dataSet){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/deleteAnexoGridAF', {
          "requestType": "DataSet",
          "dataset": dataSet
      });
    };
    
    this.getFileServerUrl = function(){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/getFileServerUrlAF', {
          "requestType": "Row",
          "row": {}
      });
    };
    
    /**
     * [FIM] ANEXO
     */
    
    this.verificaStatusAprovacaoWorkflow = function (row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/verificaStatusAprovacaoWorkflow', {
            'requestType': 'Row',
            'row': row
        });
        
    };
    
    this.indiceJoinMovindice = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/indiceJoinMovindice', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDINDICE",    "value": row.CDINDICEAF,        "operator": "="},
                {"name": "DTREFIND",    "value": row.DTREFINDAF ? row.DTREFINDAF.split(' ').shift() : row.DTREFINDAF,        "operator": "="},
                {"name": "NRORG",       "value": getLocalVar('NRORG'),  "operator": "="},
            ]
        });
    };
    
    this.getAdjustments = function (row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/getAdjustments', {
            'requestType': 'Row',
            'row': row
        });
        
    };
    
    this.retornaCookieEmail = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/retornaCookieEmail', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.retornaCookieByName = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/retornaCookieByName', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.sendEmailAFPosicionada = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sendEmailAFPosicionada', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.sendEmailAFSelecionada = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sendEmailAFSelecionada', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp03900_LancamentoAutorizacaoDeFornecimento_Service', Cmp03900_LancamentoAutorizacaoDeFornecimento_Service);
});