function Cmp04900_RelacaoDeSolicitacoesDeCompras_Controller(General, ScreenService, localStorageEngine, MessageService) {

    var self = this;

    this.limpaFieldUnidades = function(fieldUnidades) {
        fieldUnidades.setValue([]);
    };
    
    this.iniciaTela = function(widget) {
        const fieldDtEntrega = widget.getField('DTENTREGA');
        
        fieldDtEntrega.defaultValue = {
            "start": moment().format('DD/MM/YYYY'),
            "end": moment().format('DD/MM/YYYY')
        };
        
        widget.getField('IDUTPRORIGOBRIG').defaultValue = ['S', 'N'];
        
        widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        const filialField = widget.getField("CDFILIAL");
        filialField.dataSourceFilter = [
            {
                "name": "CDGRUPFILI",
                "value": "T",
                "operator": "="
            },
            {
                "name": "CDOPERADOR",
                "value": getLocalVar('CDOPERADOR'),
                "operator": "="
            }
        ];
        filialField.reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILIAL = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.filialgrupfili.forEach(function(filial) {
    	               if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete widget.currentRow.CDFILIAL;
    	               delete widget.currentRow.NMFILIAL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
                    if(filialField.readOnly == true) {
                        let verificador = 0;
                        success.dataset.filialgrupfili.forEach(function(filial) {
                            if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
                                verificador++;
                            }
                        });
                        if(verificador == 0) {
                            filialField.validations.required = true;
    	                    MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                    delete widget.currentRow.CDFILIAL;
    	                    delete widget.currentRow.NMFILIAL;
    	                    filialField.reload();
                        } else {
                            delete filialField.validations.required;
    	                    filialField.reload();
    	                }
                    }
                });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
            filialField.reload();
        });
    };

    this.nivelSetEdit = function(field) {
        const nivelButton = field.widget.getField('NIVEL');

        if (field.value().toUpperCase() == "ALFABÉTICA") {
            nivelButton.readOnly = false;
            nivelButton.spin = true;
            nivelButton.validations = {
                "required": {}
            };
        } else {
            nivelButton.readOnly = true;
            nivelButton.spin = false;
            nivelButton.value(0);
            nivelButton.validations = undefined;
        }
    };

    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
    };

    this.filtraUnidades = function(widget) {
        const groupFili = widget.currentRow.UNIDADES;
        const fieldUnidades = widget.getField('CDFILIAL');

        if (groupFili) {
            const unidades = groupFili.split('_');

            fieldUnidades.dataSourceFilter = [{
                "name": "CDFILIAL",
                "value": "",
                "operator": "IN"
            }];
            
            this.defineSelectWidget(fieldUnidades);
            
            General.onClickDependentField(fieldUnidades, {
                'CDFILIAL': unidades
            });
        } else {
            fieldUnidades.dataSourceFilter = [{
                "name": "NRORG",
                "value": "",
                "operator": "="
            }];

            this.defineSelectWidget(fieldUnidades);
            
            General.onClickDependentField(fieldUnidades, {
                'NRORG': getLocalVar('NRORG')
            });
        }
        fieldUnidades.reload();
    };

    this.defineSelectWidget = function(field) {
        if (field.selectWidget) {
            field.selectWidget.dataSourceFilter = field.dataSourceFilter;
        }
    };

    this.setVisibleProdObrigatorio = function(widget) {
        const widgetCurrentRow = widget.currentRow;
        const fieldOrigObrig = widget.getField("IDUTPRORIGOBRIG");

        if (widgetCurrentRow.REPORT_NAME == "CMP04909" || widgetCurrentRow.REPORT_NAME == "CMP0490A" || widgetCurrentRow.REPORT_NAME == "CMP0490B") {
            fieldOrigObrig.readOnly = false;
        } else {
            fieldOrigObrig.readOnly = true;
        }

        fieldOrigObrig.setValue(['S', 'N']);
    };

    this.criaRelatorio = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && this.validaProduto(currentRowWidget.CDPRODINI, currentRowWidget.CDPRODFIN)) {
            const reportName = widget.currentRow.REPORT_NAME;
            General.openReportPopup(widget, this.abreRelatorio, [widget, currentRowWidget, reportName]);
        }
    };

    this.abreRelatorio = function(widget, currentRow, reportName) {
        const row = angular.copy(currentRow);
        const niveis = General.getLevelByMask('CDPICTPROD', 1);
        
        if (row.NRTAMCODIGO == "Código") {
            row.VLR_NIVEL = parseInt(niveis[niveis.length - 1].caracteres);
        } else {
            if (row.NIVEL == "0") {
                row.VLR_NIVEL = parseInt(row.NIVEL);
            } else {
                row.VLR_NIVEL = parseInt(niveis[row.NIVEL - 1].caracteres);
            }
        }

        row.TDTINI = row.DTINI = row.DTENTREGA.start;
        row.TDTFIM = row.DTFIM = row.DTENTREGA.end;
        row.CDPRODINICOC = row.CDPRODINI;

        row.CDPRODFIMCOC = row.CDPRODFIN.padEnd(20,'Z');
        row.CDGRUPFILI = row.CDGRUPFILI ? Array.isArray(row.CDGRUPFILI) && row.CDGRUPFILI.length > 0 ? row.CDGRUPFILI.join('_') : 'T' : 'T';
        row.CDFILIAL   = row.CDFILIAL ? Array.isArray(row.CDFILIAL) && row.CDFILIAL.length > 0 ? row.CDFILIAL.join('_') : 'T' : 'T';
        
        row.CDFILIAL1 = row.CDFILIAL;
        row.CDGRUPFILI1 = row.CDGRUPFILI;

        row.CDFILIAL2 = row.CDFILIAL;
        row.CDGRUPFILI2 = row.CDGRUPFILI;
        row.IDUTPRORIGOBRIG = row.IDUTPRORIGOBRIG.join('_');
        row.NRORG = getLocalVar('NRORG');
        
        General.openReport("cmp_relatorio#/cmp04900_relatorio", reportName, row);
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04900_RelacaoDeSolicitacoesDeCompras_Controller', Cmp04900_RelacaoDeSolicitacoesDeCompras_Controller);
});